#ifndef _XRDOSSCACHE_TRACE_H
#define _XRDOSSCACHE_TRACE_H
/******************************************************************************/
/*                                                                            */
/*                        X r d O s s C a c h e T r a c e . h h               */
/*                                                                            */
/* (C) 2003 by the Board of Trustees of the Leland Stanford, Jr., University  */
/*                            All Rights Reserved                             */
/*   Produced by Andrew Hanushevsky for Stanford University under contract    */
/*                DE-AC03-76-SFO0515 with the Deprtment of Energy             */
/******************************************************************************/

//         $Id: XrdOssCacheTrace.hh,v 1.0 2009-10-19 00:00:00 ajp Exp $

#include "XrdOuc/XrdOucTrace.hh"

// Trace flags
//
#define TRACE_ALL       0x1fff
#define TRACE_Error     0x1000
#define TRACE_Open      0x0001
#define TRACE_Read      0x0002
#define TRACE_Sync      0x0004
#define TRACE_Cache     0x0008
#define TRACE_Stats     0x0010
#define TRACE_Debug     0x0800
#ifndef NODEBUG

#include "XrdSys/XrdSysHeaders.hh"

#define QTRACE(act) OssCacheTrace.What & TRACE_ ## act

#define TRACE(act, x) \
        if (QTRACE(act)) \
           {OssCacheTrace.Beg(epname,tident); cerr <<x; OssCacheTrace.End();}

#define TRACEReturn(type, ecode, msg) \
               {TRACE(type, "err " <<ecode <<msg); return ecode;}

#define DEBUG(y) if (QTRACE(Debug)) \
                    {OssCacheTrace.Beg(epname); cerr <<y; OssCacheTrace.End();}

#define EPNAME(x) const char *epname = x;

#else

#define DEBUG(x)
#define QTRACE(x) 0
#define TRACE(x, y)
#define TRACEReturn(type, ecode, msg) return ecode
#define EPNAME(x)

#endif
#endif
