#define MAX_REQUEST (32*1024)
#define SOCK_CLOSED 0
#define SOCK_OPEN 1
#define SOCK_KEEPALIVE 2
#define PROTO_HTTP 0
#define TIMEOUT 30
#define HEADER_SIZE 1024
#define min(x, y) ((x) < (y) ? (x) : (y))

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <assert.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>

class XrdOssHttpRead {
public:
  long long Size;
  int sockfd;

  typedef struct url {
    int proto;
    int timeout;
    char * host; /*hostname*/
    int port;
    char * path; /*get path*/
    char * name; /*file name*/
    int sockfd;
    int sock_type;
    char * req_buf;
    size_t req_buf_size;
    size_t file_size;
    time_t last_modified;
  } struct_url;
  
  struct_url *url;

  ssize_t exchange(char * buf, const char * method,size_t * content_length, off_t start, off_t end, size_t * header_length);
  ssize_t parse_header(const char* buf, ssize_t bytes, const char* method, size_t *content_length, int expect);
  ssize_t get_stat(struct stat * stbuf);
  ssize_t get_data(off_t start, size_t size);
  int open_client_socket();
  int read_client_socket(void * buf, size_t len);
  ssize_t write_client_socket(const void * buf, size_t len);
  int close_client_socket();
  int close_client_force();
  int mempref(const char * mem, const char * pref, size_t size);

  ssize_t Read(char* buffer, off_t start, size_t size);

  XrdOssHttpRead() {
    url = 0;
  }

  int parse_url(const char* url, struct_url* res);

  int Open(const char* inurl) {
    if (parse_url(inurl, url)==-1) return EINVAL;
    if (init_url()==-1) return EINVAL;
    sockfd = open_client_socket();
    if(sockfd < 0) {
        fprintf(stderr, "Connection failed.\n");
        return 3;
    }
    
    close_client_socket();


    struct stat st;
    Size = get_stat(&st);
    if(Size < 0) {
      return 3;
    }

    ssize_t Read(char* buffer, off_t start, size_t size);

    
  }
  
  int init_url() {
    memset(url, 0, sizeof(url));
    url->sock_type = SOCK_CLOSED;
    url->timeout = TIMEOUT;
    return 0;
  }
  
};
